module M01_direct where

-- Integer arithmetic with (+) and (/)
data Term = 
      N Int
    | Plus Term Term
    | Div Term Term

--
-- Basic evaluator
--

eval :: Term -> Int
eval (N n) = n
eval (Plus t1 t2) = eval t1 +     eval t2
eval (Div t1 t2)  = eval t1 `div` eval t2

--
-- Evaluator that counts the number of operations
--

inc :: Int -> Int
inc n = n + 1

evalWithCount :: Term -> (Int, Int)
evalWithCount t = eval' (0, t)
  where
    eval' :: (Int, Term) -> (Int, Int)
    eval' = undefined
    -- The exercise works best if you only use "inc" to bump the accumulator

--
-- Evaluator that catches division by zero
--
-- Returns (Ok n) in case of success
-- Returns (Error "Division by zero") otherwise
--

data Result a = Error String | Ok a

evalChecked :: Term -> Result Int
evalChecked = undefined
