module M02_monadic where

-- Integer arithmetic with (+) and (/)
data Term = 
      N Int
    | Plus Term Term
    | Div Term Term

--
-- Basic evaluator
--

eval :: Term -> Int
eval (N n) = n
eval (Plus t1 t2) = eval t1 +     eval t2
eval (Div t1 t2)  = eval t1 `div` eval t2

--
-- Evaluator that counts the number of operations
--
-- Returns (Ok n) in case of success
-- Returns (Error "Division by zero") otherwise
--

-- Type of computations having access to a counter, which produce an "a"
type Counter a = (Int -> (Int, a))

returnC :: a -> Counter a
returnC x = undefined

bindC :: Counter a -> (a -> Counter b) -> Counter b
bindC m f = undefined

-- "Run" a Counter computation "c", with initial counter state "s0"
runC :: Counter a -> Int -> (Int, a)
runC s0 c = undefined

-- Increment the counter
inc :: Counter ()
inc = undefined

evalWithCount :: Term -> (Int, Int)
evalWithCount t = runC (eval' t) 0
  where
    eval' :: Term -> Counter Int
    eval' = undefined

--
-- Evaluator that catches division by zero
--

data Result a = Error String | Ok a deriving Show

returnR :: a -> Result a
returnR x = undefined

bindR :: Result a -> (a -> Result b) -> Result b
bindR m f = undefined

-- Raise an exception
throw :: String -> Result a
throw s = undefined

evalChecked :: Term -> Result Int
evalChecked = undefined
